#ifndef _DIRENT_H_
#define _DIRENT_H_

#include <types.h>

#ifndef MAXNAMLEN
#define MAXNAMLEN	DIRNAMELEN
#endif

/* Directory stream type.  */
typedef struct {
	int dd_fd;		/* file descriptor */
	int dd_loc;		/* offset in buffer */
	int dd_size;		/* # of valid entries in buffer */
	struct dirent *dd_buf;	/* -> directory buffer */
} DIR;				/* stream data from opendir() */

typedef int (*__dir_select_fn_t)(struct dirent *);

typedef int (*__dir_compar_fn_t)(struct dirent **, struct dirent **);

struct dirent {
	unsigned	d_ino;
	unsigned	d_off;	/* ??? off_t - index in directory[] */
	unsigned short	d_reclen;
	char		d_name[MAXNAMLEN+1];
};

extern DIR *opendir(char *__name);
extern int closedir(DIR * __dirp);
extern struct dirent *readdir(DIR * __dirp);
extern void rewinddir(DIR * __dirp);

extern void seekdir(DIR * __dirp, off_t __pos);
extern off_t telldir(DIR * __dirp);

/* Scan the directory DIR, calling SELECT on each directory entry.
   Entries for which SELECT returns nonzero are individually malloc'd,
   sorted using qsort with CMP, and collected in a malloc'd array in
   *NAMELIST.  Returns the number of entries selected, or -1 on error.
 */
extern int scandir(char *__dir,
			 struct dirent ***__namelist,
			 __dir_select_fn_t __select,
			 __dir_compar_fn_t __compar);

#endif /* _DIRENT_H_ */
