#ifndef _PWD_H_
#define _PWD_H_

#include <types.h>
#include <stdio.h>

/* The passwd structure.  */
struct passwd {
	char	*pw_name;	/* Username */
	char	*pw_passwd;	/* Password */
	uid_t	pw_uid; 	/* User ID */
	gid_t	pw_gid; 	/* Group ID */
	char	*pw_gecos;	/* Real name */
	char	*pw_dir;	/* Home directory */
	char	*pw_shell;	/* Shell program */
};

extern void setpwent(void);
extern void endpwent(void);
extern struct passwd *getpwent(void);

extern int putpwent(struct passwd * __p, FILE * __f);
extern int getpw(int uid, char *buf);

extern struct passwd *fgetpwent(FILE *file);

extern struct passwd *getpwuid(int __uid);
extern struct passwd *getpwnam(char *);

extern struct passwd * __getpwent(int passwd_fd);

extern char *_path_passwd;

#define getlogin()	getpwnam(getuid())

#endif /* _PWD_H_ */
