#ifndef _SYS_TYPES_H_
#define _SYS_TYPES_H_

#include <features.h>

typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;
typedef long long	quad_t;
typedef unsigned long long	u_quad_t;

typedef signed char	int8_t;
typedef signed short	int16_t;
typedef signed long	int32_t;
typedef unsigned char	u_int8_t;
typedef unsigned short	u_int16_t;
typedef unsigned long	u_int32_t;

typedef unsigned short	dev_t;
typedef u_long	ino_t;
typedef u_int	mode_t;
typedef u_int	nlink_t;
typedef long	off_t;
typedef u_long	rlim_t;
typedef u_int	size_t;	/* should size_t and ssize_t be long? */
typedef int	ssize_t;

typedef int	pid_t;
typedef int	uid_t;
typedef int	gid_t;

#if 0

/* this goes in <sys/times.h> */
/* User's structure for times() system call */
struct tms {
	time_t	tms_utime;
	time_t	tms_stime;
	time_t	tms_cutime;
	time_t	tms_cstime;
	time_t	tms_etime;	/* Elapsed real time */
};

#ifndef utimbuf_is_defined
#define utimbuf_is_defined
/* User's structure for utime() system call */
struct utimbuf {
	time_t	actime;
	time_t	modtime;
};
#endif

/* this goes in <sys/stat.h> */
/* data structure for stat() */
struct stat {			/* USER! Really only used by users */
	unsigned int	st_dev; 	/* device number */
	unsigned int	st_ino; 	/* inode number */
	mode_t	st_mode;	/* file mode */
	unsigned int	st_nlink;	/* number of links */
	unsigned int	st_uid; 	/* owner id */
	unsigned int	st_gid; 	/* owner group */
	unsigned int	st_rdev;	/* */
	off_t	st_size;	/* file size */
	time_t	st_atime;	/* last access time */
	time_t	st_mtime;	/* last modification time */
	time_t	st_ctime;	/* file creation time */
};

/* FIXME */
#define DIRNAMELEN	14

/* device directory entry */
typedef struct s_direct {
	unsigned int d_ino;		/* file's inode */
	char	d_name[DIRNAMELEN];	/* file name */
} direct_t;

#endif

#ifndef NULL
#define NULL		((void *)0)
#endif

/* FIXME */
#define BUFSIZE 	512	/* uzix buffer/block size */
#define BUFSIZELOG	9	/* uzix buffer/block size log2 */

/* FIXME */
#ifndef BUFSIZ
#ifdef PC_HOSTED
#define BUFSIZ		512	/* stdio buffer size */
#else
#define BUFSIZ		256	/* 512 is too much. MSX memory is little. */
#endif
#endif

/* FIXME */
#define PATHLEN 	256

#endif /* _SYS_TYPES_H_ */
