/*
 * Punix, Puny Unix kernel
 * Copyright 2005 Chris Williams
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <sys/punix.h>
#include <sys/proc.h>
#include <sys/glo.h>

#define OS_NAME	"Punix"
#define OS_VERSION	"0.03"

STARTUP(void sched()){ while (1); } /* don't return */
STARTUP(int schedcpu()){ return 0; }

int newproc();
int kputs(char *);

/*
 * initialisation function
 * we start here as soon as we have a stack
 * here we
 * 	setup core
 * 	setup root filesystem
 * 	build process 0
 * 	start the clock
 * 	start multitasking
 * 	fork
 */
STARTUP(void kmain())
{
	struct proc *p;
	int i;
	
	kputs(OS_NAME " v" OS_VERSION "\n");
	kputs(
			"Copyright 2005 Chris Williams\n"
			"Some portions Copyright 2003 PpHd\n"
			"\n"
			"This program comes with ABSOLUTELY NO WARRANTY.\n"
			"You may redistribute copies of this program\n"
			"under the terms of the GNU General Public License.\n"
			"\n");
	
	/* initialise core (setup heap and memory resources) */
	
	/* initialise proc structure */
	/* are these values correct and all I need? */
	for (p = &GLOBAL_proc[0]; p < &GLOBAL_proc[NR_PROC]; ++p)
		p->p_status = P_FREE;
	
	CURRENT = &GLOBAL_proc[0];
	for (i = 0; i < NR_OPEN; ++i)
		P.p_ofile[i] = NULL;
	
	P.p_pid = 0;
	P.p_uid = 0;
	P.p_status = P_RUNNING;
	P.p_nice = P.p_pri = 0;
	GLOBAL_cputime = P.p_cpu = 4;
	
	/* start the clock (setup the interrupt handler) */
	
	/* start multitasking (setup the interrupt handler) */
	
	/* finish starting up the kernel */
	if (newproc()) {
		return; /* jump to icode */
	} else
		sched();
}
