#! /bin/sh

PROGRAMNAME='mksymdefs.sh'

usage() {
	echo "Usage:  $PROGRAMNAME address deffile_base [...]" >&2
	exit 1
}

if [ $# -lt 1 ]; then usage; fi

address="$1"
shift

# proc.h
export NR_PROC=20
export SIZEOFSTRUCTPROC=400	# much bigger than actually is

for f in "$@"; do
	deffile="$f.def"; cfile="$f.h"; sfile="$f.inc"
	>"$cfile"; >"$sfile"
	while read line; do
		#set $line		# this expands '*'s to a list of files (bad)
		#symname="$1"; shift
		#symsize="$1"; shift
		#symtype="$@"
		
		# strip comments (comments begin with '#')
		line="`echo "$line" |
		  sed 's/^\([^#]*\)\([	 ]*#.*\)$/\1/'`"
		# blank lines
		if echo "$line" | grep -q '^[ \t]*$'; then
			continue;
		fi
		
		symname="GLOBAL_`echo "$line"|cut -f 1`"
		symsize="`echo "$line"|cut -f 2`"
		symindi="`echo "$line"|cut -f 3`" # levels of indirection (0 for arrays, 1 for regular variables)
		symtype="`echo "$line"|cut -f 4-`"
		echo "$symname	= $address" >>"$sfile"
		(echo -n "#define $symname	("
		for ((i=0;i<symindi;++i)); do echo -n "*"; done
		echo "($symtype *)$address)") >>"$cfile"
		((address += symsize))
	done <"$deffile"
done
